Subject: Re: Write Combining for PowerPC?

From: Antonio Vargas <[email-masked]>
Date: Fri, 17 Dec 2004 22:16:19 +0100

On Fri, 10 Dec 2004 13:23:06 -0800, Kendall Bennett
<[email-masked]> wrote:
> Hi Guys,
> 
> We are working on some PowerPC machines and noticed that the boxes don't
> appear to support the equivalent of Write Combining that we get on x86
> boxes. Copies to Video Memory on our Motorola Sandpoint box run about
> 10Mb/s, which is terribly, terribly slow!
> 
> Does anyone know if it is possible to do something similar to Write
> Combining for the PowerPC architecture, to speed up CPU access to the
> linear framebuffer? Part of the problem is that for video overlay support

hmmm... G4 processors will do write-combining when you write two
cachelines just one after the other... there is a write-queue on the
cpu and when there is 1 write on the queue and you add another one for
the next cacheline, it will automatically merge the write. Also, if
you manage to complete a sector, then he knows you don't need to
read-then-write the memory and just issues a "kill-this-cacheline" on
the bus instead of "please-i-need-exclusive-access-for-this-cacheline"

> (not motion compensation) you have to dump the entire YUV frame into
> video memory for the hardware overlay, and even on a 1GHz PPC box playing
> an MPEG2 stream is not possible as X takes up over 80% of the CPU just to
> copy the YUV data to video memory!
> 
> Obviously bus mastering will help solve this problem, but it would be
> better if there was a way to enabling faster CPU access to the
> framebuffer as well.

bus mastering is DMA-ing from system memory to gfxcard memory?
 
> Regards,
> 
> ---
> Kendall Bennett
> Chief Executive Officer
> SciTech Software, Inc.
> Phone: (530) 894 8400
> http://www.scitechsoft.com
> 
> ~ SciTech SNAP - The future of device driver technology! ~
> 
> _______________________________________________
> Linuxppc-dev mailing list
> [email-masked]
> https://ozlabs.org/mailman/listinfo/linuxppc-dev
> 

-- 
Greetz, Antonio Vargas aka winden of network

http://wind.codepixel.com/

Las cosas no son lo que parecen, excepto cuando parecen lo que si son.